# coding: utf-8

"""
    Alfresco Content Services REST API

    **Core API**  Provides access to the core features of Alfresco Content Services.   # noqa: E501

    OpenAPI spec version: 1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from alfresco_core_api_client.configuration import Configuration


class ActionConstraint(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'constraint_name': 'str',
        'constraint_values': 'list[ActionConstraintData]'
    }

    attribute_map = {
        'constraint_name': 'constraintName',
        'constraint_values': 'constraintValues'
    }

    def __init__(self, constraint_name=None, constraint_values=None, _configuration=None):  # noqa: E501
        """ActionConstraint - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._constraint_name = None
        self._constraint_values = None
        self.discriminator = None

        if constraint_name is not None:
            self.constraint_name = constraint_name
        if constraint_values is not None:
            self.constraint_values = constraint_values

    @property
    def constraint_name(self):
        """Gets the constraint_name of this ActionConstraint.  # noqa: E501

        Name of the constraint.   # noqa: E501

        :return: The constraint_name of this ActionConstraint.  # noqa: E501
        :rtype: str
        """
        return self._constraint_name

    @constraint_name.setter
    def constraint_name(self, constraint_name):
        """Sets the constraint_name of this ActionConstraint.

        Name of the constraint.   # noqa: E501

        :param constraint_name: The constraint_name of this ActionConstraint.  # noqa: E501
        :type: str
        """

        self._constraint_name = constraint_name

    @property
    def constraint_values(self):
        """Gets the constraint_values of this ActionConstraint.  # noqa: E501

        A list of constraint possbile values along with additional data (label, isNode flag). Sample object could be: ```JSON \"constraintValues\": [            {               \"value\": \"EQUALS\",               \"label\": \"Equals\"            },            {               \"value\": \"CONTAINS\",               \"label\": \"Contains\"            },            {               \"value\": \"BEGINS\",               \"label\": \"Begins With\"            },            {               \"value\": \"ENDS\",               \"label\": \"Ends With\"            },            {               \"value\": \"GREATER_THAN\",               \"label\": \"Greater Than\"            },            {               \"value\": \"GREATER_THAN_EQUAL\",               \"label\": \"Greater Than Or Equal To\"            },            {               \"value\": \"LESS_THAN\",               \"label\": \"Less Than\"            },            {               \"value\": \"LESS_THAN_EQUAL\",               \"label\": \"Less Than Or Equal To\"            }         ] ``` or ```JSON \"constraintValues\": [                         {                             \"value\": \"fa41fd6e-5640-410f-9f3e-93f268186f69\",                             \"label\": \"Start Pooled Review and Approve Workflow\",                             \"isNode\": true                         }                     ] ```   # noqa: E501

        :return: The constraint_values of this ActionConstraint.  # noqa: E501
        :rtype: list[ActionConstraintData]
        """
        return self._constraint_values

    @constraint_values.setter
    def constraint_values(self, constraint_values):
        """Sets the constraint_values of this ActionConstraint.

        A list of constraint possbile values along with additional data (label, isNode flag). Sample object could be: ```JSON \"constraintValues\": [            {               \"value\": \"EQUALS\",               \"label\": \"Equals\"            },            {               \"value\": \"CONTAINS\",               \"label\": \"Contains\"            },            {               \"value\": \"BEGINS\",               \"label\": \"Begins With\"            },            {               \"value\": \"ENDS\",               \"label\": \"Ends With\"            },            {               \"value\": \"GREATER_THAN\",               \"label\": \"Greater Than\"            },            {               \"value\": \"GREATER_THAN_EQUAL\",               \"label\": \"Greater Than Or Equal To\"            },            {               \"value\": \"LESS_THAN\",               \"label\": \"Less Than\"            },            {               \"value\": \"LESS_THAN_EQUAL\",               \"label\": \"Less Than Or Equal To\"            }         ] ``` or ```JSON \"constraintValues\": [                         {                             \"value\": \"fa41fd6e-5640-410f-9f3e-93f268186f69\",                             \"label\": \"Start Pooled Review and Approve Workflow\",                             \"isNode\": true                         }                     ] ```   # noqa: E501

        :param constraint_values: The constraint_values of this ActionConstraint.  # noqa: E501
        :type: list[ActionConstraintData]
        """

        self._constraint_values = constraint_values

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ActionConstraint, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ActionConstraint):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ActionConstraint):
            return True

        return self.to_dict() != other.to_dict()
